using System;
using System.Collections.Generic;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using Infragistics.Windows;
using Infragistics.Windows.Editors;
using Infragistics.Windows.Editors.Events;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.Events;
using System.Diagnostics;
using System.Data;

using System.Collections;
using Infragistics.Windows.Controls;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Globalization;


namespace WPF___WindowsApplication2
{
	/// <summary>
	/// Interaction logic for Window1.xaml
	/// </summary>

	public partial class Window1 : System.Windows.Window
	{
		public Window1( )
		{
            DataContext = new ModelView();
			InitializeComponent( );
		}


		public void OnLoaded( object sender, EventArgs e )
		{
		    
		}
	}

	// A sample validation rule.
	public class RangeValidationRule : ValidationRule
	{
		private double _min, _max;

        public RangeValidationRule()
        {
            _min = -2000;
            _max = 2000;
        }


		public override ValidationResult Validate( object value, CultureInfo cultureInfo )
		{
			try
			{
				
                double val = Convert.ToDouble( value );

				if ( val < _min || val > _max )
					return new ValidationResult( false, 
						string.Format( "Value must be within {0} and {1} inclusive!", _min, _max ) );
			}
			catch ( Exception e )
			{
				return new ValidationResult( false, e );
			}

			return new ValidationResult( true, null );
		}

	}

	// Derive a class from the editor. Add ValidationRules property and override 
	// ValidateCurrentValue to validate against those rules.
	public class MyTextEditor : XamTextEditor
	{
		protected override bool ValidateCurrentValue( out Exception error )
		{
			// First check if the base implementation validates the value.
			if ( !base.ValidateCurrentValue( out error ) )
				return false;

			object value = this.Value;
			CultureInfo cultureInfo = this.FormatProvider as CultureInfo;

            if (null != ValidationRule)
			{

			    ValidationResult result = ValidationRule.Validate(value, cultureInfo);
                if (!result.IsValid)
                {
                    string message = null != result.ErrorContent
                        ? result.ErrorContent.ToString()
                        : "Validation Failed";

                    error = new Exception(message);
                    return false;
                }
                
			}

			return true;
		}

		public static readonly DependencyProperty ValidationRuleProperty = DependencyProperty.Register(
			"ValidationRule", typeof( ValidationRule ), typeof( MyTextEditor ) );

		public ValidationRule ValidationRule
		{
			get
			{
				return (ValidationRule)this.GetValue( ValidationRuleProperty );
			}
			set
			{
				this.SetValue( ValidationRuleProperty, value );
			}
		}
	}
}